import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class here.
 * 
 * @author Team3
 */
public class Avatar extends Creature
{
    public int speed = 2;
    private theWorld mworld;
    private int invinciblecount = 0;
    String stat = "";
    String facing = "down";
    private int cycleCount = 0;
    int[] keyholder = {0,0,0,0,0,0,0,0,0};
    public int speedBootsTimer = 300;
    /**
     * Act - do whatever the Guy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void addedToWorld(World world) 
    {
        mworld = (theWorld) world;  
    } // end addedToWorld

    /**
     * The method check() is used to determine if a level exit is reached.
     */
    public boolean check()
    {
        Actor LevelExit;
        LevelExit = getOneObjectAtOffset(0, 0, LevelExit.class);     

        if (LevelExit != null)
            return true;

        return false;
    }

    public void act() 
    {
        if(!theWorld.isPaused()){
            invincibleCheck();
            createWaterbullet(facing);
            createNomsbullet(facing);
            //touchingRock();
            speedboots();

            if (!(Greenfoot.isKeyDown("down")||Greenfoot.isKeyDown("up")||Greenfoot.isKeyDown("right")||Greenfoot.isKeyDown("left")))
            {
                cycleCount = 0;
                if(facing == "down")
                    imageCycle(1);
                else if(facing == "up")
                    imageCycle(2);
                else if(facing == "right")
                    imageCycle(3);
                else if(facing == "left")
                    imageCycle(4);

            }
            if (Greenfoot.isKeyDown("down") && mworld.lives >= 0)
            {
                imageCycle(1);
                facing = "down";
                mworld.facing = facing;
                if (!touches (Obstacle.class))
                {
                    setLocation(getX(), getY() + speed); 
                    doorCheck();
                }
                if (touches (Obstacle.class) || getY() > 640 || touches2(Rock.class))
                    setLocation(getX(), getY() - speed);   
                mworld.setCoords(getX(), getY());
            }

            if (Greenfoot.isKeyDown("up") && mworld.lives >= 0)
            {
                imageCycle(2);
                facing = "up";
                mworld.facing = facing;
                if (!touches (Obstacle.class))
                {
                    setLocation(getX(), getY() - speed); 
                    doorCheck();
                }  
                if (touches (Obstacle.class) || touches2(Rock.class))
                    setLocation(getX(), getY() + speed);
                mworld.setCoords(getX(), getY() );
            }

            if (Greenfoot.isKeyDown("right") && mworld.lives >= 0)
            {
                imageCycle(3);
                facing = "right";
                mworld.facing = facing;
                if (!touches (Obstacle.class))
                {
                    setLocation(getX() + speed, getY() ); 
                    doorCheck();
                }      
                if (touches (Obstacle.class) || getX() > 540 || touches2(Rock.class))
                    setLocation(getX() - speed, getY());     
                mworld.setCoords(getX(), getY());  
            }

            if (Greenfoot.isKeyDown("left") && mworld.lives >= 0)
            {
                imageCycle(4);
                facing = "left";
                mworld.facing = facing;
                if (!touches (Obstacle.class))
                {
                    setLocation(getX() - speed, getY() ); 
                    doorCheck();
                }      
                if (touches (Obstacle.class) || getX() < 20 || touches2(Rock.class))
                    setLocation(getX() + speed, getY());
                mworld.setCoords(getX(), getY());
            }
            cycleCount++;
        }
    }  

    public void speedboots()
    {       
        // if you want the speed boots to last a brief period of time, use this code
        // otherwise comment it out
        if (mworld.speedBootsActive == true && speedBootsTimer > 0)
        {
            speedBootsTimer--;
        }
        if (mworld.speedBootsActive == true && speedBootsTimer == 0)
        {
            mworld.speedBootsActive = false;
            speedBootsTimer = 300;
        }         
    }

    public void touchingRock()
    {
        if(mworld.moveBack == true)
        {
            if (mworld.facing == "right")
                setLocation(getX() - 2, getY());
            if (mworld.facing == "left")
                setLocation(getX() + 2, getY());
            if (mworld.facing == "up")
                setLocation(getX(), getY() + 2);
            if (mworld.facing == "down")
                setLocation(getX(), getY() - 2);

            mworld.moveBack = false;
        }
    }

    public void createWaterbullet(String f)
    {
        if (Greenfoot.isKeyDown("x") && mworld.waterGunActive == true && mworld.canCreateNewBullet == true)
        {
            WaterBullet bullet = new WaterBullet(f);
            mworld.addObject(bullet, mworld.CoordsX, mworld.CoordsY);
            mworld.canCreateNewBullet = false;
        }
    }

    public void createNomsbullet(String f)
    {
        if (Greenfoot.isKeyDown("z") && mworld.poisonNomsBagActive == true && mworld.canCreateNewNoms == true)
        {
            PoisonNoms noms = new PoisonNoms(f);
            mworld.addObject(noms, mworld.CoordsX, mworld.CoordsY);
            mworld.canCreateNewNoms = false;
        }
    }

    /**
     * Checks to see if the Avatar is still invincible after taking damage
     */
    private void invincibleCheck()
    {
        if(touches2(Enemy.class) && invinciblecount == 0) 
        {    
            if(touches2(Skeleton.class))
            {   Skeleton skele = (Skeleton) getOneObjectAtOffset(0,0,Skeleton.class);
                if(skele != null && !skele.isDead())
                {
                    if (mworld.shieldActive == false)
                        mworld.lives--;
                    lifeCheck();
                    mworld.shieldActive = false;
                    invinciblecount = 100;
                }
            }
            else
            {
                if (mworld.shieldActive == false)
                    mworld.lives--;
                lifeCheck();
                mworld.shieldActive = false;
                invinciblecount = 100;
            }

        }
        else if(touches2(FirePit.class) && invinciblecount == 0)
        {
            if(mworld.shieldActive == false)
                mworld.lives--;
            lifeCheck();
            mworld.shieldActive = false;
            invinciblecount = 100;
        }
        else if(touches2(BottomlessPit.class))
        {
            if (mworld.floatingBootsActive == false)
                mworld.lives = -1;
            lifeCheck();
        }
        else if(touches2(TimedSpikeTrap.class) && invinciblecount == 0)
        {
            if (mworld.spikeDangerous == true && mworld.shieldActive == false)
            {
                mworld.lives--;
                lifeCheck();
                invinciblecount = 100;
            }
            if(mworld.spikeDangerous == true && mworld.shieldActive == true)
            {
                mworld.shieldActive = false;
                invinciblecount = 100;
            }
        }
        else if(invinciblecount > 0)
        {
            invinciblecount--;
        }
    }

    public void hit()
    {
        if(invinciblecount == 0)
        {
            if(mworld.shieldActive == false)
                mworld.lives--;
            lifeCheck();
            mworld.shieldActive = false;
            invinciblecount = 100;
        }
    }

    /**
     * Cycles the images based on various criteria
     */
    private void imageCycle(int face)
    {
        if(invinciblecount > 0)
        {
            stat = "blink";
        }
        else 
        {
            stat = "";
        }

        if(cycleCount == 0 || cycleCount == 20)
            setImage("Avatar"+face+"a"+stat+".png");
        if(cycleCount == 10)
            setImage("Avatar"+face+"b"+stat+".png");
        if(cycleCount == 30)
            setImage("Avatar"+face+"c"+stat+".png");

        if(cycleCount==40)
            cycleCount = 0;

    }
    private void doorCheck()
    {
        if(touches(Door.class))
        {
            Class clss = Door.class;
            Actor door;
            door = getOneIntersectingObject(clss);
            removeDoor((Door) door);

        }
    }

    private void removeDoor(Door door )
    {
        if(keyholder[door.doorcolor]==1)
            getWorld().removeObject(door);
    }

    /**
     * Checks to see if Avatar is still alive
     */
    private void lifeCheck()
    {
        if(mworld.lives < 0)
        {
            mworld.setLevel(-1);
            getWorld().removeObject(this);
        }
    }
}
