import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Opens door of same color when all enemies of same color are dead.
 * 
 * @author Team 3 cs371 fall 2011 
 * @version 1.0
 */
public class ContextLever extends Item
{
    private int color;
    private boolean lit;
    private List doorlist;
    private List enemylist;
    /**
     * Act - Checks to see if enemy of same color still exists, if not opens door of same color. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        enemylist = getWorld().getObjects(Enemy.class);
        doorlist = getWorld().getObjects(Door.class);
        lit = true;
        for(int i = 0; i< enemylist.size();i++)
        {
           Enemy enemy = (Enemy) enemylist.get(i);
           if(enemy.getColor() == color)
           {
               lit = false;
           }   
        }
        if(lit)
        {
            if(color==1)
                this.setImage("BlueContextLeverLit.png");
            else if(color==2)
                this.setImage("RedContextLeverLit.png");
            else if(color==3)
                this.setImage("YellowContextLeverLit.png");
            else if(color==4)
                this.setImage("GreenContextLeverLit.png");
            else if(color==5)
                this.setImage("OrangeContextLeverLit.png"); 
            else if(color==6)
                this.setImage("PurpleContextLeverLit.png");
            else if(color==7)
                this.setImage("BrownContextLeverLit.png");
            else if(color==8)
                this.setImage("GreyContextLeverLit.png");
            for(int j = 0; j< doorlist.size();j++)
            {
               Door door = (Door) doorlist.get(j);
               if(door.doorcolor == color)
               {
                        getWorld().removeObject(door);                   
               } 
            }
        }
    }    
    /**
     * Contructor
     * @param lcolor Color of switch, enemy it checks for, and door it opens.
     */
    public ContextLever(int lcolor)
    {
        color = lcolor;
        if(color==1)
            this.setImage("BlueContextLever.png");
        else if(color==2)
            this.setImage("RedContextLever.png");
        else if(color==3)
            this.setImage("YellowContextLever.png");
        else if(color==4)
            this.setImage("GreenContextLever.png");
        else if(color==5)
            this.setImage("OrangeContextLever.png"); 
        else if(color==6)
            this.setImage("PurpleContextLever.png");
        else if(color==7)
            this.setImage("BrownContextLever.png");
        else if(color==8)
            this.setImage("GreyContextLever.png");
        else
        {
            color =1 ;
            this.setImage("GreyContextLever.png");
        }
    } 
}
