import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Abstract class for items that player avatar can move around the map.
 * 
 * @author Team 3 cs371 fall 2011 
 * @version 1.0
 */
public class Pushable extends Item
{
    private theWorld mworld;
    /**
     * Called upon creation to set which world item is in.
     */
    public void addedToWorld(World world) 
    {
        mworld = (theWorld) world;  
    }
    /**
     * Act - do whatever the Pushable wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
       
    }   
    
    /**
     * Checks to see if player avatar is trying to push the pushable and if it is in an allowed direction.
     */
    protected void pushed()
    {
        if (touches(Avatar.class))
        {
            if (mworld.facing == "right")
            {
                setLocation(getX() + 1, getY());
                if (touches(Obstacle.class) || touches(Enemy.class) || touches(Pushable.class) || getX() > 540 )
                {
                    mworld.moveBack = true;
                    setLocation(getX() - 1, getY());
                }
            }
            
            if (mworld.facing == "left")
            {
                setLocation(getX() - 1, getY());
                if (touches(Obstacle.class) || touches(Enemy.class) || touches(Pushable.class) || getX() < 20 )
                {
                    mworld.moveBack = true;
                    setLocation(getX() + 1, getY());
                }
            }
            
            if (mworld.facing == "up")
            {
                setLocation(getX(), getY() - 1);
                if(touches(Obstacle.class) || touches(Enemy.class) || touches(Pushable.class))
                {
                    mworld.moveBack = true;
                    setLocation(getX(), getY() + 1);
                }
            }   
            
            if (mworld.facing == "down")
            {
                setLocation(getX(), getY() + 1);
                if (touches(Obstacle.class) || touches(Enemy.class) || touches(Pushable.class) || getY() > 640)
                {
                    mworld.moveBack = true;
                    setLocation(getX(), getY() - 1);
                }
            }        
        }      
    }
}
