import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.List;
import java.net.*;
/**
 * Main class of the game.
 * 
 * @author Team 3 cs371 fall 2011 
 * @version 2.0 
 */
public class theWorld extends World
{
    public int CoordsX, CoordsY;
    public int score = 0;
    public int lives = 3;
    public int level = 0;
    boolean shieldActive = false; 
    boolean floatingBootsActive = false;
    boolean waterGunActive = false;
    boolean canCreateNewBullet = false;
    boolean poisonNomsBagActive = false;
    boolean canCreateNewNoms = false;
    boolean speedBootsActive = false;
    boolean spikeDangerous = false;
    static private boolean gamePaused;
    public boolean moveBack = false;
    
    String facing = "";

    /**
     * Constructor for objects of class theWorld.
     * 
     */
    public theWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(560, 660, 1,true);
        // specifies which images are given priority
        setPaintOrder(Button.class, AllScreens.class, Avatar.class, Rock.class, Plate.class, Item.class, Stats.class, statboard.class, Enemy.class);
        prepare();
        setLevel(level);
        level++;
        gamePaused = false;
    }

    public void act()
    {
        openMenu();
    }
    
    /**
     * Checks to see if the escape key has been pressed to open the menu
     */
    public void openMenu()
    {
        if (Greenfoot.isKeyDown("escape") && gamePaused == false)
        {            
            MenuInterface menu = new MenuInterface();
            addObject(menu,285,350);
            ResumeButton resumeButton = new ResumeButton();
            addObject(resumeButton, 285, 350);
            SaveButton saveButton = new SaveButton();
            addObject(saveButton, 285,240);
            ExitButton exitbuttonpause = new ExitButton();
            addObject(exitbuttonpause, 289, 458);
            ItemGuideButton itemguidebuttonpause = new ItemGuideButton();
            addObject(itemguidebuttonpause, 455, 453);
            gamePaused = true;
            Greenfoot.delay(20);
        }
        else if (Greenfoot.isKeyDown("escape") && gamePaused == true)
        {
            gamePaused = false;
            removeObjects(getObjects(Button.class));
            Greenfoot.delay(20);
        }
    }
    
    /**
     * Returns whether or not the game is paused
     */
    static public boolean isPaused()
    {
        return gamePaused;
    }
    
    /**
     * Unpauses the game
     */
    static public void unPause()
    {
        gamePaused = false;
    }
    
    /**
     * Adds specified int to the score
     */
    public void addScore(int a)
    {
        score = score +a;
    }
    
    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        scorekeeper scorekeeper = new scorekeeper();
        addObject(scorekeeper, 200, 30);
        lifekeeper lifekeeper = new lifekeeper();
        addObject(lifekeeper, 200, 18);
        statboard statboard = new statboard();
        addObject(statboard, 300, 50);
    }
    
    // NOTE: If adding MORE levels, be sure to see the LevelExit class for more info OTHERWISE the level may not appear in the game
    /**
     * Removes previous level objects, resets powerup flags and sets background of specified level
     */
    protected void setLevel(int levelto)
    {
        removeObjects(getObjects(MapObject.class));
        removeObjects(getObjects(Enemy.class));
        removeObjects(getObjects(LevelExit.class));
        statboard statboard = new statboard();
        addObject(statboard, 300, 50);
        
        // prevents an item's power from carrying over to the next level
        shieldActive = false;
        floatingBootsActive = false;
        waterGunActive = false;
        canCreateNewBullet = false;
        //speedBootsActive = false;
        poisonNomsBagActive = false;
        canCreateNewNoms = false;
        level = levelto;
        switch(level)
        {
            case 0:
                setBackground("floor.png");
                MenuInterface menuInterface = new MenuInterface();
                addObject(menuInterface, 285, 350);
                StartButton startButton = new StartButton();
                //addObject(startButton, (getHeight()-100)/2, getWidth()/2);
                addObject(startButton, 288, 368);
                LoadButton loadButton = new LoadButton();
                addObject(loadButton, 177, 455);
                ExitButton exitButton = new ExitButton();
                addObject(exitButton, 399, 455);
                TutorialButton tutorialButton = new TutorialButton();
                addObject(tutorialButton, 289, 455);
                break;
            case 1:
                setBackground("floor.png");
                readLevel(level);
                gamePaused = true;
                StoryScreen1 storyscreen1 = new StoryScreen1();
                addObject(storyscreen1, 285, 350);
               break;
            case 2:
                setBackground("floor2.png");
                readLevel(level);
               break;
            case 3:
                setBackground("floor3.png");
                readLevel(level);
               break;
            case 4:
                setBackground("floor4.png");
                readLevel(level);
               break;
            case 5:
                setBackground("floor1.png");
                readLevel(level);
               break;
            case 6:
                setBackground("floor2.png");
                readLevel(level);
               break;
            case 7:
                setBackground("floor3.png");
                readLevel(level);
               break;
            case 8:
                setBackground("floor4.png");
                readLevel(level);
               break;
            case 9:
                setBackground("floor1.png");
                readLevel(level);
               break;
            case 10:
                setBackground("floor.png");
                StoryScreen2 storyscreen2 = new StoryScreen2();
                addObject(storyscreen2, 285, 350);
                break;
            case 99:
                setBackground("floor.png");
                TutorialScreen tut7 = new TutorialScreen();
                addObject(tut7, 285, 350);
                break;
            default:
                TheEndButton theEndButton = new TheEndButton();
                addObject(theEndButton, (getHeight()-100)/2, getWidth()/2);
               break;
        }
    }
    
    /**
     * Sets coordinates of the player
     */
    public void setCoords(int wx, int wy)
    {
        CoordsX = wx;
        CoordsY = wy;
    } // end setCoords
    
    /**
     * Returns the y coordinate of the player
     */
    public int getCoordY()
    {
        return CoordsY;
    }
    
    /**
     * Returns the x coordinate of the player
     */
    public int getCoordX()
    {
        return CoordsX;
    }
    
    /**
     * Reads a level#.txt file of 14 x 14 of 2 digit alpha-numeric codes for map-objects and creatures
     */
     public void readLevel(int level)
    {
        try
        {
            InputStream thefile = openFile("level"+Integer.toString(level)+".txt"); 
            BufferedReader in = new BufferedReader(new InputStreamReader(thefile));
            String line;
            char[] readLine = new char[42];
            char first;
            char second;
            for(int j = 0; j < 14; j++)
            {
                line = in.readLine();
                readLine = line.toCharArray();
                for(int i = 0; i < 14; i++)
                {
                    first = readLine[i*3];
                    second = readLine[i*3+1];
                    spawnLevelObject(first,second,i,j); 
                }
            }
        }catch( IOException e){System.out.println("Level file not setup correctly");}
        
    }
    
    /**
     * Used to read level#.txt files
     */
    public InputStream openFile(String fileName) throws IOException 
    { 
        URL url = getClass().getClassLoader().getResource(fileName); 
        if(url == null) throw new IOException("File not found: " + fileName); 
        return url.openStream();
    }
 
    /**
     * Returns the active player avatar object
     */
    public Avatar getPlayer()
    {
        List list;
        list = getObjects(Avatar.class);
        if(list.get(0) != null)
            return (Avatar) list.get(0);
        else 
            return null;
    }
    
    /**
     * Given a 2 digit alpha-numeric a,b and position i,j creates specified object at specified position
     */
    private void spawnLevelObject(char a,char b, int i,int j)
    {
        switch(a){
            case '0': ;
                break;
            
            case '1':  Wall wall = new Wall(b-48);
                     addObject(wall, 20+(i*40), 120+(j*40) );
                break;
                
            case 'A': Avatar avatar = new Avatar();
                    addObject(avatar, 20+(i*40), 120+(j*40) );
                break;
                
            case 'D': Door door = new Door(b-48);
                    addObject(door, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'S': 
                    if(b=='H')
                    {
                        Shield shield = new Shield();
                        addObject(shield, 20+(i*40), 120+(j*40) );
                    }
                    else if(b=='B')
                    {
                        SpeedBoots sboots = new SpeedBoots();
                        addObject(sboots, 20+(i*40), 120+(j*40) );
                    }
                    else
                    {
                        Lever lever = new Lever(b-48);
                        addObject(lever, 20+(i*40), 120+(j*40) ); 
                    }
                break;
                
            case 'K': Key key = new Key(b-48);
                    addObject(key, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'C': ContextLever context = new ContextLever(b-48);
                    addObject(context, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'R': Rock rock = new Rock(b-48);
                    addObject(rock, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'P': Plate plate = new Plate(b-48);
                    addObject(plate, 20+(i*40), 120+(j*40) ); 
                break;
                
            case '+': HealthPack health = new HealthPack();
                    addObject(health, 20+(i*40), 120+(j*40) ); 
                break;
                
            case '*': EnemyBlockTile tile = new EnemyBlockTile();
                    addObject(tile, 20+(i*40), 120+(j*40) ); 
                break;    
                
            case 'T': Turret turret = new Turret(b-48);
                    addObject(turret, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'F': FloatingBoots fboots = new FloatingBoots();
                    addObject(fboots, 20+(i*40), 120+(j*40) ); 
                break;
                
            case 'G': 
                if(b=='W')
                {
                    WaterGun wg = new WaterGun();
                    addObject(wg, 20+(i*40), 120+(j*40) ); 
                }
                if(b=='P')
                {
                    PoisonNomsBag pg = new PoisonNomsBag();
                    addObject(pg, 20+(i*40), 120+(j*40) ); 
                }
                break;
                
            case 'g': Gobbler gobbler = new Gobbler(b-48);
                    addObject(gobbler, 20+(i*40), 120+(j*40) );
                break;
                
            case 'p': Spitter spitter = new Spitter(b-48);
                    addObject(spitter, 20+(i*40), 120+(j*40) );
                break;
                
            case 's': Skeleton skeleton = new Skeleton();
                    addObject(skeleton, 20+(i*40), 120+(j*40) );
                break;
                
            case '2': FirePit firepit = new FirePit();
                    addObject(firepit, 20+(i*40), 120+(j*40) );
                break;
                
            case '3': BottomlessPit pit = new BottomlessPit();
                    addObject(pit, 20+(i*40), 120+(j*40) );
                break;
                
            case '4': TimedSpikeTrap trap = new TimedSpikeTrap();
                    addObject(trap, 20+(i*40), 120+(j*40) );
                break;
                
            case '9': LevelExit levelexit = new LevelExit();
                    addObject(levelexit, 20+(i*40), 120+(j*40) );
                break;
                
            default: System.out.println("Not a valid MapObject at " +i+","+j);
                break;
        }
    }
    
    
}
